<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Chat - DSC Corporate</title>
    <style>
        body { margin: 0; padding-bottom: 3rem; font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif; }
        h4 {
            font-size: 11px;
        }

        h3 {
            font-size: 18px;
        }
        
        .rightChat {
            text-align: right;
            min-width: 60px;
            max-width: 700px;
            float: right;
            border: 2px solid #dedede;
            background-color: #E2FFC7;
            border-radius: 16px 16px 0 16px;
            padding: 14px 18px;
            margin: 6px 8px;
        }
        .leftChat {
            text-align: left;
            min-width: 60px;
            max-width: 700px;
            float: left;
            border: 2px solid #ccc;
            background-color: #F7FCF6;
            border-radius: 16px 16px 0 16px;
            padding: 14px 18px;
            margin: 6px 8px;
        }
        .afterText {
            content: "";
            clear: both;
            display: table;
        }
        .msg-info-name {
            align-self: flex-start;
        }
        span.own{
            font-size: 12px;
            color: grey;
        }
        span.other{
            font-size: 12px;
            color: grey;
        }
        span.msg-info-name {
            font-size: 12px;
            margin-right: 20px;
            font-weight: bold;
            color: grey;
            }
      
      
      #form { background: rgba(0, 0, 0, 0.15); padding: 0.25rem; position: fixed; bottom: 0; left: 0; right: 0; display: flex; height: 3rem; box-sizing: border-box; backdrop-filter: blur(10px); }
      #input { border: none; padding: 0 1rem; flex-grow: 1; border-radius: 2rem; margin: 0.25rem; }
      #input:focus { outline: none; }
      #form > button { background: #333; border: none; padding: 0 1rem; margin: 0.25rem; border-radius: 3px; outline: none; color: #fff; }

      #messages { list-style-type: none; margin: 0; padding: 0; }
      #messages > li { padding: 0.5rem 1rem; width: px;}
      
    </style>
    <script>
        scrollingElement = (document.scrollingElement || document.body)
        function scrollToBottom() {
            scrollingElement.scrollTop = scrollingElement.scrollHeight ;
        }
    </script>
    <script src="../../socket.io/socket.io.js"></script>
    <script src="http://code.jquery.com/jquery-1.10.1.min.js"></script>
    </head>
    <body>
    <% var username = username; %>
    <% var room = room; %>
    <ul id="messages"></ul>
    <form action="/" method="POST" id="form">
      <input id="input" autocomplete="off" autofocus="on" placeholder="type your message here..." /><button>Send</button>
      <input type="hidden" id="username" name="username" value="<%= username %>">
      <input type="hidden" id="room" name="room" value="<%= room %>">
    </form>
    <script>
            var socket = io.connect();

            // submit text message without reload/refresh the page
            $('form').submit(function(e){
                e.preventDefault(); // prevents page reloading
                msg = $('#input').val();
                if (msg != "") {
                    username = $('#username').val();
                    room = $('#room').val();
                    let currentDate = new Date();
                    let currentChatTime = String(currentDate.getHours()).padStart(2, "0")+":"+String(currentDate.getMinutes()).padStart(2, "0");
                    socket.emit('chat-message',{ msg,username,room,currentChatTime });
                    scrollToBottom();
                }
                $('#input').val('');
                return false;
            });

            // append the chat text message
            socket.on('chat-message', function(data){
              if(username === data.username) {
                $('#messages').append($('<li class="rightChat"><span class="own">' + data.currentChatTime + '</span><p>' + data.msg + '</li>'));
                $('#messages').append($('<li class="afterText">'));
              }
              else {
                $('#messages').append($('<li class="leftChat"><span class="msg-info-name">' + data.username +'</span><span class="other">'+ data.currentChatTime + '</span><p>' + data.msg + '</li>'));
                $('#messages').append($('<li class="afterText">'));
              }
              scrollToBottom();
            });

            socket.on('chat-history', function(data,cekUser){
              if (username == cekUser) {
                if(username === data.username) {
                  $('#messages').append($('<li class="rightChat"><span class="own">' + data.currentChatTime + '</span><p>' + data.msg + '</li>'));
                  $('#messages').append($('<li class="afterText">'));
                }
                else {
                  $('#messages').append($('<li class="leftChat"><span class="msg-info-name">' + data.username +'</span><span class="other">'+ data.currentChatTime + '</span><p>' + data.msg + '</li>'));
                  $('#messages').append($('<li class="afterText">'));
                }
              }
              scrollToBottom();
            });

            // join room
            var username = "<%= username %>";
            var room = "<%= room%>";
            socket.emit('join-room', { username,room });


    </script>
  </body>
</html>